#Evolution d'un système chimique vers son état final
import matplotlib.pyplot as plt    
import numpy as np
plt.close('all')

########################################
#paramétrage de l'équation de réaction à compléter
NomsR=['xxx','xxx','xxx']#Noms des réactifs
NomsP=['xxx','xxx','xxx']#Noms des produits
n0R=[0,0,0]#Quantités de réactifs initales
n0P=[0,0,0]#Quantités de produits initiales
stoeR=[0,0,0]#Nombres stoechimoétriques des réactifs
stoeP=[0,0,0]#Nombres stoechimoétriques des produits
########################################

def etat_final(n0R,n0P,stoeR,stoeP):
    
    #Détermination de l'avancement maximal
    rapports=[]
    for i in range(len(n0R)):
        rapports.append(n0R[i]/stoeR[i])
    xmax=min(rapports)
    
    #Détermination de l'état final du système
    nfR=len(n0R)*[0]
    for i in range(len(n0R)):
            nfR[i]=n0R[i]-stoeR[i]*xmax
    nfP=len(n0P)*[0]
    for i in range(len(n0P)):
        nfP[i]=n0P[i]+stoeP[i]*xmax
    return xmax,nfR,nfP

##########################################
#Mise en forme du message de réponse
xmax,nfR,nfP=etat_final(n0R,n0P,stoeR,stoeP)
nf=nfR+nfP
Noms=NomsR+NomsP
print('xmax='+'{0:.2e}'.format(xmax)+' mol')#xmax écrit en notation scientifique avec deux chiffres après la vigule
print("A l'état final il y a :")
for i in range(len(Noms)):
    print('{0:.2e}'.format(nf[i])+ ' mol de '+ Noms[i])
###########################################   
 
###########################################
#Rerésentation graphique de l'évolution du système au cours de la réaction.
    
def evolution(n0R,n0P,stoeR,stoeP,N):
    xmax=etat_final(n0R,n0P,stoeR,stoeP)[0]
    x=np.linspace(0,xmax,N)
    nR=np.zeros((len(n0R),N))
    nP=np.zeros((len(n0P),N))
    for k in range(N):
        for i in range(len(nR)):
            nR[i][k]=n0R[i]-stoeR[i]*x[k]
        for i in range(len(nP)):
            nP[i][k]=n0P[i]+stoeP[i]*x[k]
    return x,list(nR)+list(nP)
 
x,n=evolution(n0R,n0P,stoeR,stoeP,10)

    